program Test
use sep

implicit none
integer::n1,n2,i1,i2
real   ::d1,d2
real   ::q,b1,b2,c1,c2
real   ::spacestuff,omega,k1,k2,kay,v,dt
real   ::pi

real, dimension(:,:),allocatable::vphase

call sep_init()

pi=3.1415926535

call from_history("n1",n1)
call from_history("n2",n2)

call from_history("d1",d1)
call from_history("d2",d2)

call from_par("v",v,1.)
call from_par("dt",dt,.3)

call from_par("q",q,1.)
call from_par("b1",b1,4./3.)
call from_par("b2",b2,4./3.)
call from_par("c1",c1,-1./12.)
call from_par("c2",c2,-1./12.)

call sep_close()

allocate (vphase(n1,n2))

do i2=1,n2
   k2=float(i2)*pi/(n2*d2)

   do i1=1,n1
      k1=float(i1)*pi/(n1*d1)

      kay=sqrt(k1*k1+k2*k2)

      spacestuff=b2*(2*cos(k2*d2)-2.)/(d2*d2)+b1*(2.*cos(k1*d1)-2.)/(d1*d1)+c1*(2.*cos(2*k1*d1)-2.)/(d1*d1)+c2*(2.*cos(2*k2*d2)-2.)/(d2*d2)
      spacestuff=spacestuff*v*v*dt*dt
      omega=1./dt*acos(spacestuff/2.+1.)
      vphase(i1,i2)=omega/kay

   end do
end do

call sep_write(vphase)

deallocate (vphase)

call exit(0)

end program Test
