subroutine objecfn(v,dt,d1,d2,n1,n2,b1,b2,c1,c2,                  &
                   Err,dErr_db1,dErr_db2,dErr_dc1,dErr_dc2,       &
                   ktransition,kmax        )   
                     
implicit none

integer            ::n1,n2,i1,i2

double precision   ::d1,d2
double precision   ::b1,b2,c1,c2
double precision   ::br,cr,er,fr,gr

double precision   ::spacestuff,omega,k1,k2,kay,v,dt
double precision   ::fspacestuff,fomega,kr,dr,fdt
double precision   ::preomega,fpreomega
double precision   ::vdtd1_squared,vdtd2_squared,vdtdr_squared
double precision   ::CC1_1,CC1_2,CC2_1,CC2_2
double precision   ::CC1_r,CC2_r,CC3_r,CC4_r,CC5_r
double precision   ::pi

double precision   ::vphase,vtarget,wate
double precision   ::dErr_db1,dErr_db2,dErr_dc1,dErr_dc2,Err
double precision   ::kmax,ktransition


! Some silly constants

br=5./3.
cr=-5./21
er=5./126.
fr=-5./1008.
gr=1./3150.

fdt=.1*min(d1,d2)/v
dr=min(d1,d2)


pi=3.14159265358979323846

vdtd1_squared=v*v*dt*dt/(d1*d1)
vdtd2_squared=v*v*dt*dt/(d2*d2)
vdtdr_squared=v*v*fdt*fdt/(dr*dr)

! initializations

Err=dble(0.)
dErr_db1=dble(0.)
dErr_db2=dble(0.)
dErr_dc1=dble(0.)
dErr_dc2=dble(0.)

!write(0,*)' '
!write(0,*)'entry test'
!write(0,*)vdtd1_squared,vdtd2_squared,vdtdr_squared
!write(0,*)' '


do i2=1,n2
   k2=dble(i2)*pi/(n2*d2)

   do i1=1,n1

      k1=dble(i1)*pi/(n1*d1)

      kay=sqrt(k1*k1+k2*k2)
      kr=kay

      CC1_1=2.*cos(1.*k1*d1)
      CC2_1=2.*cos(2.*k1*d1)
      CC1_2=2.*cos(1.*k2*d2)
      CC2_2=2.*cos(2.*k2*d2)

      CC1_r=2.*cos(1.*kr*dr)
      CC2_r=2.*cos(2.*kr*dr)
      CC3_r=2.*cos(3.*kr*dr)
      CC4_r=2.*cos(4.*kr*dr)
      CC5_r=2.*cos(5.*kr*dr)

      spacestuff= b1*vdtd1_squared*(CC1_1-2.)+                        &
                  b2*vdtd2_squared*(CC1_2-2.)+                        &
                  c1*vdtd1_squared*(CC2_1-2.)+                        &
                  c2*vdtd2_squared*(CC2_2-2.)                    

      preomega=spacestuff/2+1.
      omega=1./dt*acos(preomega)
      vphase=omega/kay

      fspacestuff= br*vdtdr_squared*(CC1_r-2.)+                     &
                   cr*vdtdr_squared*(CC2_r-2.)+                     &
                   er*vdtdr_squared*(CC3_r-2.)+                     &
                   fr*vdtdr_squared*(CC4_r-2.)+                     &
                   gr*vdtdr_squared*(CC5_r-2.)

      fpreomega=fspacestuff/2+1.
      fomega=1./fdt*acos(fpreomega)
      vtarget=fomega/kay

! a weight function

     wate=1./(kay)**1.5

     if(kay > ktransition .and. kay < kmax)then
       wate=wate*(1-(kay-ktransition)/(kmax-ktransition))
     end if

     if(kay >  kmax)then
       wate=0.
     end if

!     wate=1.

     Err=Err+wate*(vphase-vtarget)**2
     dErr_db1=dErr_db1-wate*(vphase-vtarget)/(dt*kay)*(1.0/sqrt(1.-preomega**2))*vdtd1_squared*(CC1_1-2.)
     dErr_db2=dErr_db2-wate*(vphase-vtarget)/(dt*kay)*(1.0/sqrt(1.-preomega**2))*vdtd2_squared*(CC1_2-2.)
     dErr_dc1=dErr_dc1-wate*(vphase-vtarget)/(dt*kay)*(1.0/sqrt(1.-preomega**2))*vdtd1_squared*(CC2_1-2.)
     dErr_dc2=dErr_dc2-wate*(vphase-vtarget)/(dt*kay)*(1.0/sqrt(1.-preomega**2))*vdtd2_squared*(CC2_2-2.)

!if(i1 == i2 .and. mod(i1,10) == 0 )then
!  write(0,*)'vphase,vtarget',vphase,vtarget,Err
!end if

   end do
end do

! At this point we've summed up the objective function and all it's first derivatives

return

end subroutine objecfn
