program Test
use sep

implicit none
integer::n1,n2,i1,i2
real   ::d1,d2
real   ::q,b,c
real   ::s,t,r
real   ::spacestuff,omega,k1,k2,kay,v,dt,spacestuff1,spacestuff2
real   ::pi

real, dimension(:,:),allocatable::vphase

call sep_init()

pi=3.1415926535

call from_history("n1",n1)
call from_history("n2",n2)

call from_history("d1",d1)
call from_history("d2",d2)

call from_par("v",v,1.)
call from_par("dt",dt,.3)

call from_par("q",q,1.)
call from_par("b",b,4./3.*.75)
call from_par("c",c,-1./12.*.75)

call from_par("s",s,4./3.*.25)
call from_par("t",t,-1./12.*.25)

call to_history("n2",n1)

call sep_close()

allocate (vphase(n1,n1))

do i2=1,n1
   k2=float(i2)*pi/(n1*d1)

   do i1=1,n1
      k1=float(i1)*pi/(n1*d1)

      kay=sqrt(k1*k1+k2*k2)

      spacestuff1=b*(2*cos(k2*d1)-2.)/(d1*d1)+b*(2.*cos(k1*d1)-2.)/(d1*d1)+c*(2.*cos(2*k1*d1)-2.)/(d1*d1)+c*(2.*cos(2*k2*d1)-2.)/(d1*d1)

      spacestuff2=s*(4*cos(k2*d1)*cos(k1*d1)-4.)/(2*d1*d1)+t*(4.*cos(2*k1*d1)*cos(2*k2*d1)-4.)/(2*d1*d1)

      spacestuff=spacestuff1*v*v*dt*dt+spacestuff2*v*v*dt*dt
      omega=1./dt*acos(spacestuff/2.+1.)
      vphase(i1,i2)=omega/kay

   end do
end do

call sep_write(vphase)

deallocate (vphase)

call exit(0)

end program Test
