program Test

use sep

implicit none
integer::n1,n2,i1,i2
real   ::d1,d2
real   ::q,b,c,e
real   ::bd,cd,ed
real   ::spacestuff,omega,k1,k2,kay,v,dt,spacestuff1,spacestuff2
real   ::pi,weight,dweight

real, dimension(:,:),allocatable::vphase,error_a

call sep_init()

pi=3.1415926535

call from_history("n1",n1)
call from_history("n2",n2)

call from_history("d1",d1)
call from_history("d2",d2)

call from_par("v",v,1.)
call from_par("dt",dt,.3)

call from_par("weight",weight,.75)
call from_par("dweight",dweight,.25)

call from_par("q",q,1.)
call from_par("b",b,4./3.*.75)
call from_par("c",c,-1./12.*.75)
call from_par("e",e,0.)

call from_par("bd",bd,4./3.*.25)
call from_par("cd",cd,-1./12.*.25)
call from_par("ed",ed,0.)

call to_history("n2",n1)
call to_history("n3",2)

call sep_close()

allocate (vphase(n1,n1))
allocate (error_a(n1,n1))

do i2=1,n1
   k2=float(i2)*pi/(n1*d1)

   do i1=1,n1
      k1=float(i1)*pi/(n1*d1)

      kay=sqrt(k1*k1+k2*k2)

      spacestuff1=b*(2*cos(k2*d1)-2.)/(d1*d1)+b*(2.*cos(k1*d1)-2.)/(d1*d1)+                 &
                  c*(2.*cos(2*k1*d1)-2.)/(d1*d1)+c*(2.*cos(2*k2*d1)-2.)/(d1*d1)+            &
                  e*(2.*cos(3*k1*d1)-2.)/(d1*d1)+e*(2.*cos(3*k2*d1)-2.)/(d1*d1)             

      spacestuff2=bd*(4*cos(k2*d1)*cos(k1*d1)-4.)/(2*d1*d1)+                                &
                  cd*(4.*cos(2*k1*d1)*cos(2*k2*d1)-4.)/(2*d1*d1)+                           &
                  ed*(4.*cos(3*k1*d1)*cos(3*k2*d1)-4.)/(2*d1*d1)                            

      spacestuff=weight*spacestuff1*v*v*dt*dt+dweight*spacestuff2*v*v*dt*dt
      omega=1./dt*acos(spacestuff/2.+1.)
      vphase(i1,i2)=omega/kay

   end do
end do

error_a=(vphase-v)/v

call sep_write(vphase)
call sep_write(error_a)

deallocate (vphase)

call exit(0)

end program Test
