!
! subroutine to calculate the phase velocity error 
!

subroutine vphase_7pt(b1,b2,c1,c2,e1,e2,vphase,error_a,n1,n2,d1,d2,dt,v)

implicit none

integer::n1,n2,i1,i2

real   ::d1,d2
real   ::b1,c1,e1
real   ::b2,c2,e2
real   ::br,cr,er,fr,gr
real   ::dr,fdt

real   ::vdtd1_squared,vdtd2_squared,vdtdr_squared
real   ::CC1_1,CC1_2,CC2_1,CC2_2,CC3_1,CC3_2
real   ::CC1_r,CC2_r,CC3_r,CC4_r,CC5_r

real   ::spacestuff,omega,preomega,k1,k2,kay,v,dt
real   ::pi

real   ::vphase(n1,n2),error_a(n1,n2)

pi=3.1415926535



vdtd1_squared=v*v*dt*dt/(d1*d1)
vdtd2_squared=v*v*dt*dt/(d2*d2)

do i2=1,n2
   k2=float(i2)*pi/(n2*d2)

   do i1=1,n1
      k1=float(i1)*pi/(n1*d1)

      kay=sqrt(k1*k1+k2*k2)

      CC1_1=2.*cos(k1*d1)
      CC2_1=2.*cos(2.*k1*d1)
      CC3_1=2.*cos(3.*k1*d1)

      CC1_2=2.*cos(k2*d2)
      CC2_2=2.*cos(2.*k2*d2)
      CC3_2=2.*cos(3.*k2*d2)

      spacestuff= b1*vdtd1_squared*(CC1_1-2.)+                        &
                  b2*vdtd2_squared*(CC1_2-2.)+                        &
                  c1*vdtd1_squared*(CC2_1-2.)+                        &
                  c2*vdtd2_squared*(CC2_2-2.)+                        &
                  e1*vdtd1_squared*(CC3_1-2.)+                        &
                  e2*vdtd2_squared*(CC3_2-2.)

      preomega=spacestuff/2+1.
      omega=1./dt*acos(preomega)
      vphase(i1,i2)=omega/kay


   end do
end do


! create the error maps


error_a=(vphase-v)/v

return

end subroutine vphase_7pt
